
import java.util.*;

public class irisCANT extends CANT23{
  public static String ExperimentXMLFile;
  public static irisNet nullNet;
  public static irisExperiment experiment; 
  public static int kludge = 1;
  public static irisPatternReader patReader;
  public static String trainNetName = "src/iris/irisTrain.txt";
  public static String testNetName = "src/iris/irisTest.txt";
  
  private static int testNumber = -1;
  
  public static void main(String args[]){
System.out.println("initialize CANT iris ");
   	ExperimentXMLFile = "src/iris/iris.xml";
    seed = 1;
    initRandom();
    readNewSystem();
    positionWindows();
    delayBetweenSteps=0;
    patReader = new irisPatternReader(trainNetName);
  }
  
  public static void setTestReader() {
	    patReader = new irisPatternReader(testNetName);	  
  }

  
	protected static void readNewSystem() {
		// System.out.println("readNewSystem");
			nullNet = new irisNet();

			nets = NetManager.readNets(ExperimentXMLFile, nullNet);
			workerThread = new irisCANT.WorkerThread();
			initializeExperiment();
			// experiment.printExpName();
			workerThread.start();
			connectAllNets();

			irisNet somNet = (irisNet) experiment.getNet("SomNet");
			somNet.zeroIncomingStrengths();
			updateIncomingStrengths();
			somNet.setCyclesPerRun(20);
			patReader = new irisPatternReader(trainNetName);
		System.out.println(testNumber + " Training On " + trainNetName
				+ " Testing on " + testNetName);
	}
  
  private static void connectAllNets() {
    irisNet baseNet = (irisNet)experiment.getNet("BaseNet");
	irisNet somNet = (irisNet)experiment.getNet("SomNet");
    
	baseNet.connectBaseToSomNet(somNet);
  }


  //set up the experiment specific parameters.
  private static void initializeExperiment() {
    experiment = new irisExperiment();
    //System.out.println("initialize som1 Experiment");
    experiment.printExpName();
  }

  
private static void updateIncomingStrengths() {
  //loop through all nets
  //Enumeration <?> eNum = CANT23.nets.elements();
  //while (eNum.hasMoreElements()) {
    //CANTNet net = (CANTNet)eNum.nextElement();

	//consider if input is also learning with post compensatory need to fix this.
    irisNet net = (irisNet)experiment.getNet("SomNet");

    //loop through all neurons 
    for (int cNeuron = 0; cNeuron < net.getTotalNeurons(); cNeuron++) {
      //loop through all synapses
      for (int cSynapse = 0; cSynapse < net.neurons[cNeuron].
        getCurrentSynapses(); cSynapse++) {
        if (net.neurons[cNeuron].synapses[cSynapse].getWeight() > 0) {
          double currentIncomingWeight = ((CANTNeuronSpontaneousFatigue)net.neurons[cNeuron].
        	synapses[cSynapse].toNeuron).getIncomingStrength();
          ((CANTNeuronSpontaneousFatigue)net.neurons[cNeuron].synapses[cSynapse].toNeuron)
          .setIncomingStrength(currentIncomingWeight +
            net.neurons[cNeuron].synapses[cSynapse].getWeight());
        }
      }
    }
//  }
}

  public static void runOneStepStart() {
    if (experiment.trainingLength == CANTStep ) 
    	experiment.switchToTest();
    
    //if (experiment.getInTest()) 
    	experiment.measure(CANTStep);
 
    if (experiment.isEndEpoch(CANTStep))
      experiment.endEpoch();
  }
  
  public static synchronized void resetForNewTest() {
	if(!experiment.getInTest()) return;

	Enumeration <?> eNum = nets.elements();
    while (eNum.hasMoreElements()) {
      irisNet net = (irisNet)eNum.nextElement();
      //      net.setInitialFatigue(-1.0);
      for (int i = 0; i < net.getSize(); i++) {
 	     net.neurons[i].setFatigue((float)0.0);
	     net.neurons[i].setActivation(0.0);
      }
    }
  }

  private static int numSystems = 1;
  public static synchronized int getNumSystems() {return numSystems;}
  
  public static synchronized void runOneStep() {
    //runOneStepStart();

      //System.out.println("Step " + CANTStep);
	  
	//this assumes only somNet has fatiguing neurons.
    irisNet somNet = (irisNet)experiment.getNet("SomNet");
    somNet.zeroIncomingStrengths();
    updateIncomingStrengths();

    Enumeration <?> eNum = nets.elements();
    eNum = nets.elements();
    while (eNum.hasMoreElements()) {
      irisNet net = (irisNet)eNum.nextElement();
    if (net.getName().compareTo("BaseNet") == 0)
      {
      net.runAllOneStep(CANTStep); 
      CANTStep++;
      }
    }
   
    //System.out.println("Incremenet cantvis1step"+CANTStep);

  if (experiment.experimentDone(CANTStep)) 
    {
    //System.out.println("experiment done "+CANTStep);
    closeSystem();
  	numSystems++;
  	readNewSystem();
  	//makeNewSystem(numSystems);
    }
  }
  
  
 private  static void positionWindows() {
    irisNet baseNet = (irisNet)experiment.getNet("BaseNet");
    irisNet somNet = (irisNet)experiment.getNet("SomNet");
  
    baseNet.cantFrame.setLocation(0,0);
    baseNet.cantFrame.setSize (500,400);
    baseNet.cantFrame.setVisible(true);  
    
  
    somNet.cantFrame.setLocation(500,0);
    somNet.cantFrame.setSize (400,400);
    //somNet.cantFrame.matrix.addStringsToPrint ("0",30,180);
    //somNet.cantFrame.matrix.addStringsToPrint ("1",50);

    somNet.cantFrame.setVisible(true);  
  }
  
  //embedded Thread class
  public static class WorkerThread extends CANT23.WorkerThread{
    public void run(){
      //System.out.println("xor Thread ");
      while(true){
         if(isRunning){
           runOneStep();
         }
         else{
           try{sleep(delayBetweenSteps);}
		   catch(InterruptedException ie){ie.printStackTrace();}
             }//else
       }//while
    }//run
  }//WorkerThread class
}