
import java.util.*;

public class iris2CANT extends CANT23{
  public static String ExperimentXMLFile;
  public static iris2Net nullNet;
  public static iris2Experiment experiment; 
  public static int kludge = 2;
  public static iris2PatternReader patReader;
  public static globalInhibition globInhibition;
  public static String trainNetName = "src/iris2/irisTrain.txt";
  public static String testNetName = "src/iris2/irisTest.txt";
  
  private static int testNumber = -1;
  
  public static void main(String args[]){
System.out.println("initialize CANT iris2 ");
   	ExperimentXMLFile = "src/iris2/iris2.xml";
    seed = 2;
    initRandom();
    readNewSystem();
    positionWindows();
    delayBetweenSteps=0;
    patReader = new iris2PatternReader(trainNetName);
    globInhibition = new globalInhibition();
  }
  
  public static void setTestReader() {
	    patReader = new iris2PatternReader(testNetName);	  
  }

  
	protected static void readNewSystem() {
		// System.out.println("readNewSystem");
			nullNet = new iris2Net();

			nets = NetManager.readNets(ExperimentXMLFile, nullNet);
			workerThread = new iris2CANT.WorkerThread();
			initializeExperiment();
			// experiment.printExpName();
			workerThread.start();
			connectAllNets();

			iris2Net somNet = (iris2Net) experiment.getNet("SomNet");
			somNet.zeroIncomingStrengths();
			updateIncomingStrengths();
			somNet.setCyclesPerRun(20);
			patReader = new iris2PatternReader(trainNetName);
		System.out.println(testNumber + " Training On " + trainNetName
				+ " Testing on " + testNetName);
	}
  
  private static void connectAllNets() {
    iris2Net baseNet = (iris2Net)experiment.getNet("BaseNet");
	iris2Net somNet = (iris2Net)experiment.getNet("SomNet");
	iris2Net outputNet = (iris2Net)experiment.getNet("OutputNet");
    
	baseNet.connectBaseToSomNet(somNet);
	somNet.connectSomToOutputNet(outputNet);
	outputNet.connectOutputToSomNet(somNet);
  }


  //set up the experiment specific parameters.
  private static void initializeExperiment() {
    experiment = new iris2Experiment();
    //System.out.println("initialize som1 Experiment");
    experiment.printExpName();
  }

  
	private static void updateIncomingStrengths() {
		// loop through all nets
		// Enumeration <?> eNum = CANT23.nets.elements();
		// while (eNum.hasMoreElements()) {
		// CANTNet net = (CANTNet)eNum.nextElement();

		// consider if input is also learning with post compensatory need to fix
		// this.
		iris2Net net = (iris2Net) experiment.getNet("SomNet");
		updateIncomingStrengths(net);
		net = (iris2Net) experiment.getNet("OutputNet");
		updateIncomingStrengths(net);
	}

	private static void updateIncomingStrengths(iris2Net net) {
		// loop through all neurons
		for (int cNeuron = 0; cNeuron < net.getTotalNeurons(); cNeuron++) {
			// loop through all synapses
			for (int cSynapse = 0; cSynapse < net.neurons[cNeuron]
					.getCurrentSynapses(); cSynapse++) {
				if (net.neurons[cNeuron].synapses[cSynapse].getWeight() > 0) {
					double currentIncomingWeight = ((CANTNeuronSpontaneousFatigue) net.neurons[cNeuron].synapses[cSynapse].toNeuron)
							.getIncomingStrength();
					((CANTNeuronSpontaneousFatigue) net.neurons[cNeuron].synapses[cSynapse].toNeuron)
							.setIncomingStrength(currentIncomingWeight
									+ net.neurons[cNeuron].synapses[cSynapse]
											.getWeight());
				}
			}
		}
	}

  public static void runOneStepStart() {
    if (experiment.trainingLength == CANTStep ) 
    	experiment.switchToTest();
    
    //if (experiment.getInTest()) 
    	experiment.measure(CANTStep);
 
    if (experiment.isEndEpoch(CANTStep))
      experiment.endEpoch();
  }
  
  public static synchronized void resetForNewTest() {
	if(!experiment.getInTest()) return;

	Enumeration <?> eNum = nets.elements();
    while (eNum.hasMoreElements()) {
      iris2Net net = (iris2Net)eNum.nextElement();
      //      net.setInitialFatigue(-1.0);
      for (int i = 0; i < net.getSize(); i++) {
 	     net.neurons[i].setFatigue((float)0.0);
	     net.neurons[i].setActivation(0.0);
      }
    }
  }

  private static int numSystems = 1;
  public static synchronized int getNumSystems() {return numSystems;}
  
  public static synchronized void runOneStep() {
    //runOneStepStart();

      //System.out.println("Step " + CANTStep);
	  
	//this assumes only somNet has fatiguing neurons.
    iris2Net somNet = (iris2Net)experiment.getNet("SomNet");
    somNet.zeroIncomingStrengths();
    iris2Net outputNet = (iris2Net)experiment.getNet("OutputNet");
    outputNet.zeroIncomingStrengths();
    updateIncomingStrengths();

    Enumeration <?> eNum = nets.elements();
    eNum = nets.elements();
    while (eNum.hasMoreElements()) {
      iris2Net net = (iris2Net)eNum.nextElement();
    if (net.getName().compareTo("BaseNet") == 0)
      {
      net.runAllOneStep(CANTStep); 
      CANTStep++;
      }
    }
   
    //System.out.println("Incremenet cantvis1step"+CANTStep);

  if (experiment.experimentDone(CANTStep)) 
    {
    //System.out.println("experiment done "+CANTStep);
    closeSystem();
  	numSystems++;
  	readNewSystem();
  	//makeNewSystem(numSystems);
    }
  }
  
  
 private  static void positionWindows() {
    iris2Net baseNet = (iris2Net)experiment.getNet("BaseNet");
    iris2Net somNet = (iris2Net)experiment.getNet("SomNet");
    iris2Net outputNet = (iris2Net)experiment.getNet("OutputNet");
  
    baseNet.cantFrame.setLocation(0,0);
    baseNet.cantFrame.setSize (500,400);
    baseNet.cantFrame.setVisible(true);  
   
  
    somNet.cantFrame.setLocation(500,0);
    somNet.cantFrame.setSize (350,400);
    somNet.cantFrame.setVisible(true);  

    outputNet.cantFrame.setLocation(850,0);
    outputNet.cantFrame.setSize (350,400);
    //somNet.cantFrame.matrix.addStringsToPrint ("0",30,180);
    //somNet.cantFrame.matrix.addStringsToPrint ("1",50);
    outputNet.cantFrame.setVisible(true);  
  }
  
  //embedded Thread class
  public static class WorkerThread extends CANT23.WorkerThread{
    public void run(){
      //System.out.println("xor Thread ");
      while(true){
         if(isRunning){
           runOneStep();
         }
         else{
           try{sleep(delayBetweenSteps);}
		   catch(InterruptedException ie){ie.printStackTrace();}
             }//else
       }//while
    }//run
  }//WorkerThread class
}